

(defun d-splat-control-ms ()
  (interactive)
  (save-excursion
    (goto-char (point-min))
    (while (re-search-forward "\C-m" nil t)
      (replace-match "" 'fixedcase))))

(defun d-splat-region (min max &optional point)
  (narrow-to-region min max)
  (if point
      (goto-char point))
  ;; else use the value of (point)
  ;;(goto-char (point)))
  (if buffer-read-only
      (progn
        (read-only-mode 1)
        (setq bro nil))
    (read-only-mode -1)
    (setq bro t))
  ;; -----------------------------------------------------------------
  (while (re-search-forward "." nil t)
    (replace-match "x" 'fixedcase))
  (widen)
  ;; -----------------------------------------------------------------
  (if bro
      (read-only-mode -1)
    (read-only-mode 1)))
