

(setq load-path (cons "~/dlisp/" load-path))

(require 'early-bindings)

(d-emergency-set-load-path)

(progn
  (load-file "~/dlisp/early-bindings.el")
  (load-file "~/dlisp/d-time.el")
  )

(require 'cl)

(assert (boundp 'X))
;;(setq X "hello")
;;(setq X "J.T.W")
;;(setq default-directory "~/hairy-lemon/src/50webs-com/")

(defun d-shell-command (cmd)
  (message "Executing shell command: %s" cmd)
  (shell-command cmd)
  )

(defun d-copy-file (src dest)
  (message "Executing copy %s -> %s" src dest)
  (copy-file src dest 'OK-IF-ALREADY-EXISTS 'KEEP-TIME)
  )

;;(when (not (boundp 'X))
;;  (setq X "dlisp"))
;;(setq X nil)

(defun doit ()
  (assert (and (boundp 'X) X))
  (message "X=%s" X)
  (d-shell-command (format "tar -cvf %s.tar %s" X X))
  (d-shell-command (format "gzip -fv %s.tar" X))
  (setq filename-new (concat X "-" (d-time--get-stamp) ".tar.gz"))
  (setq filename-old (concat X ".tar.gz"))
  ;;(message "**** filename-old=%s" filename-old)
  (assert (file-exists-p "~/bak"))
  (progn
    ;;(d-copy-file filename-old (concat "~/bak/" filename-old))
    (d-copy-file filename-old (concat "~/bak/" filename-new))
    ;;(message "*** after d-copy-file")
    )
  (when (and (file-exists-p "c:/")
             (not (string= (expand-file-name "~/bak/") "c:/home/bak/")))
    ;;(d-copy-file filename-old (concat "c:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "c:/home/bak/" filename-new))
    ;;(message "*** when (file-exists-p c:/")
    )
  ;;(d-copy-file filename-old (concat "~/hairy-lemon/output/davinpearson-com/binaries/" filename-old))
  (d-copy-file filename-old (concat "~/hairy-lemon/output/davinpearson-com/binaries/" filename-new))
  ;;(message "*** Calamansi filename-old=%s" filename-old)
  (message "Executing d drive")
  (when (file-exists-p "d:/")
    ;;(d-copy-file filename-old (concat "d:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "d:/home/bak/" filename-new)))
  (message "Executing e drive")
  (when (file-exists-p "e:/")
    ;;(d-copy-file filename-old (concat "e:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "e:/home/bak/" filename-new)))
  (message "Executing f drive")
  (when (file-exists-p "f:/")
    ;;(d-copy-file filename-old (concat "f:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "f:/home/bak/" filename-new)))
  (message "Executing g drive")
  (when (file-exists-p "g:/")
    ;;(d-copy-file filename-old (concat "g:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "g:/home/bak/" filename-new)))
  (message "Executing h drive")
  (when (file-exists-p "h:/")
    ;;(d-copy-file filename-old (concat "h:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "h:/home/bak/" filename-new)))
  (message "Executing i drive")
  (when (file-exists-p "i:/")
    ;;(d-copy-file filename-old (concat "i:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "i:/home/bak/" filename-new)))
  (message "Executing j drive")
  (when (file-exists-p "j:/")
    ;;(d-copy-file filename-old (concat "j:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "j:/home/bak/" filename-new)))
  (message "Executing k drive")
  (when (file-exists-p "k:/")
    ;;(d-copy-file filename-old (concat "k:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "k:/home/bak/" filename-new)))
  (message "Executing l drive")
  (when (file-exists-p "l:/")
    ;;(d-copy-file filename-old (concat "l:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "l:/home/bak/" filename-new)))
  (message "Executing m drive")
  (when (file-exists-p "m:/")
    ;;(d-copy-file filename-old (concat "m:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "m:/home/bak/" filename-new)))
  (message "Executing n drive")
  (when (file-exists-p "n:/")
    ;;(d-copy-file filename-old (concat "n:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "n:/home/bak/" filename-new)))
  (message "Executing o drive")
  (when (file-exists-p "o:/")
    ;;(d-copy-file filename-old (concat "o:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "o:/home/bak/" filename-new)))
  (message "Executing p drive")
  (when (file-exists-p "p:/")
    ;;(d-copy-file filename-old (concat "p:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "p:/home/bak/" filename-new)))
  (message "Executing q drive")
  (when (file-exists-p "q:/")
    ;;(d-copy-file filename-old (concat "q:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "q:/home/bak/" filename-new)))
  (message "Executing r drive")
  (when (file-exists-p "r:/")
    ;;(d-copy-file filename-old (concat "r:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "r:/home/bak/" filename-new)))
  (message "Executing s drive")
  (when (file-exists-p "s:/")
    ;;(d-copy-file filename-old (concat "s:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "s:/home/bak/" filename-new)))
  (message "Executing t drive")
  (when (file-exists-p "t:/")
    ;;(d-copy-file filename-old (concat "t:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "t:/home/bak/" filename-new)))
  (message "Executing u drive")
  (when (file-exists-p "u:/")
    ;;(d-copy-file filename-old (concat "u:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "u:/home/bak/" filename-new)))
  (message "Executing v drive")
  (when (file-exists-p "v:/")
    ;;(d-copy-file filename-old (concat "v:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "v:/home/bak/" filename-new)))
  (message "Executing w drive")
  (when (file-exists-p "w:/")
    ;;(d-copy-file filename-old (concat "w:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "w:/home/bak/" filename-new)))
  (message "Executing x drive")
  (when (file-exists-p "x:/")
    ;;(d-copy-file filename-old (concat "x:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "x:/home/bak/" filename-new)))
  (message "Executing y drive")
  (when (file-exists-p "y:/")
    ;;(d-copy-file filename-old (concat "y:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "y:/home/bak/" filename-new)))
  (message "Executing z drive")
  (when (file-exists-p "z:/")
    ;;(d-copy-file filename-old (concat "z:/home/bak/" filename-old))
    (d-copy-file filename-old (concat "z:/home/bak/" filename-new)))
  (message "Executing C1TB drive")
  (when (file-exists-p "/media/www/C1TB/")
    ;;(d-copy-file filename-old (concat "/media/www/C1TB/home/bak/" filename-old))
    (message "Removed d-copy-file filename-old=%s" filename-old)
    (d-copy-file filename-old (concat "/media/www/C1TB/home/bak/" filename-new)))
  (message "Executing WD2TB drive")
  (when (file-exists-p "/media/www/WD2TB/")
    (d-copy-file filename-old (concat "/media/www/WD2TB/home/bak/" filename-old))
    (d-copy-file filename-old (concat "/media/www/WD2TB/home/bak/" filename-new)))
  (message "Executing WD2TB2 drive")
  (when (file-exists-p "/media/www/WD2TB2/")
    (d-copy-file filename-old (concat "/media/www/WD2TB2/home/bak/" filename-old))
    (d-copy-file filename-old (concat "/media/www/WD2TB2/home/bak/" filename-new)))

  (message "Executing WD2TB-RED drive")
  (when (file-exists-p "/media/www/WD2TB-RED/")
    (d-copy-file filename-old (concat "/media/www/WD2TB-RED/home/bak/" filename-old))
    (d-copy-file filename-old (concat "/media/www/WD2TB-RED/home/bak/" filename-new)))

  (message "Executing WD2TB-BLU drive")
  (when (file-exists-p "/media/www/WD2TB-BLU/")
    (d-copy-file filename-old (concat "/media/www/WD2TB-BLU/home/bak/" filename-old))
    (d-copy-file filename-old (concat "/media/www/WD2TB-BLU/home/bak/" filename-new)))

  (message "Executing F2TB drive")
  (when (file-exists-p "/media/www/F2TB")
    (d-copy-file filename-old (concat "/media/www/F2TB/home/bak/" filename-old))
    (d-copy-file filename-old (concat "/media/www/F2TB/home/bak/" filename-new)))
  (message "Executing H16GB drive")
  (when (file-exists-p "/media/www/H16GB/")
    (d-copy-file filename-old (concat "/media/www/H16GB/home/bak/" filename-old))
    (d-copy-file filename-old (concat "/media/www/H16GB/home/bak/" filename-new)))
  (message "Executing I16GB drive")
  (when (file-exists-p "/media/www/I16GB/")
    (d-copy-file filename-old (concat "/media/www/I16GB/home/bak/" filename-old))
    (d-copy-file filename-old (concat "/media/www/I16GB/home/bak/" filename-new)))
  (message "Executing J600GB drive")
  (when (file-exists-p "/media/www/J600GB/")
    (d-copy-file filename-old (concat "/media/www/J600GB/home/bak/" filename-old))
    (d-copy-file filename-old (concat "/media/www/J600GB/home/bak/" filename-new)))
  (message "Executing K2TB drive")
  (when (file-exists-p "/media/www/K2TB")
    (d-copy-file filename-old (concat "/media/www/K2TB/home/bak/" filename-old-old))
    (d-copy-file filename-old (concat "/media/www/K2TB/home/bak/" filename-new-new)))
  (message "Executing BLU16GB drive")
  (when (file-exists-p "/media/www/BLU16GB/")
    (d-copy-file filename-old (concat "/media/www/BLU16GB/home/bak/" filename-old))
    (d-copy-file filename-old (concat "/media/www/BLU16GB/home/bak/" filename-new)))
  (message "Executing GRN16GB drive")
  (when (file-exists-p "/media/www/GRN16GB/")
    (d-copy-file filename-old (concat "/media/www/GRN16GB/home/bak/" filename-old))
    (d-copy-file filename-old (concat "/media/www/GRN16GB/home/bak/" filename-new)))
  ;; -----------------------------------------------------------------
  (message "deleting file %s" filename-old)
  (delete-file filename-old)
  ;; -----------------------------------------------------------------
  (setq file-to-play (if (file-exists-p "c:/")
                         "c:/sound-samples/emacs/completed-website-make-tar.wav"
                       "/media/www/C1TB/sound-samples/emacs/completed-website-make-tar.wav"))
  (message "inside d-tar.el file-to-play=%s" file-to-play)
  (load-file "~/dlisp/play-wav.el")
  (message "*** d-tar.el finished")
  )
