
;;; Comment me to avoid syntax highlighting of variables
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(setq prefs-font-variables-and-properties t)
(defmacro d-quote (&rest rest)
  )

(setq load-path (cons "~/dlisp/" load-path))

(setq inhibit-startup-echo-area-message "www")

;;(load-file "~/dlisp/diagnose.el")

(setq prefs-syntax-highlighting nil)

(message "cp0")

(progn

;;; Limitation of Warranty

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs, see the file COPYING.  If not, see:
;;
;; <http://www.gnu.org/licenses/gpl-3.0.txt>.


;; This file is a copy of my GNU/Linux ~/.emacs file.

;;; Code:

  (progn
    (setq bg-color-p nil)
    (setq os-type-linux-p t)
    )

  (message "cp1")

  (progn
    (setq load-path (cons "~/dlisp/" load-path))
    (load-file (concat (car load-path) "/early-bindings.el"))
    )

  (message "cp2")

  (progn
    (setq debug-ignored-errors (cdr debug-ignored-errors))
    (setq debug-ignored-errors (remove 'beginning-of-buffer debug-ignored-errors))
    (setq debug-ignored-errors (remove "Args out of range" debug-ignored-errors))
    (setq debug-ignored-errors (remove 'search-failed debug-ignored-errors))
    (setq debug-ignored-errors (remove "Symbol's function definition is void" debug-ignored-errors))
    (setq debug-ignored-errors (add-to-list 'debug-ignored-errors 'beginning-of-buffer))
    (setq debug-ignored-errors (remove "Selecting deleted buffer" debug-ignored-errors))
    )

  (message "cp3")

  (defun d-emergency-set-load-path ()
    (setq load-path (cons "~/cedet-1.1/" load-path))
    (setq load-path (cons (expand-file-name "~www/dlisp/imported-stuff/") load-path))
    (setq load-path (cons (expand-file-name "~www/dlisp/") load-path))
    (message "~/.emacs (car load-path=%s)" (car load-path))
    )

  (message "cp4")

  (d-emergency-set-load-path)

  (message "cp5")

  (require 'eieio)

  (d-emergency-set-load-path)

  (message "cp6")

  (safe-require 'dired-colours)

  (defun d-init-dired-colours ()
    (let ((d-message-on t))
      (message "BEG d-init-dired-colours")
      (setq dc-files-list--text        (append '("lzz") dc-files-list--text))
      (setq dc-files-list--sources     (append `(,(regexp-quote "c++")
						 ,(regexp-quote "ch++")
						 ,(regexp-quote "h++")
						 "function" "method" "c2j" "glued" "ch" "inc" "mk" "src" "jtw" "el[+][+]"
                                                 , (regexp-quote "lisp++"))
					       dc-files-list--sources))

      (setq dc-files-list--sources     (remove "cpp" dc-files-list--sources))

      (setq dc-files-list--executable  (append '("run" "swf")       dc-files-list--executable))
      (setq dc-files-list--unimportant (append '("oldel[0-9]*$" "dep" "num" "tm4") dc-files-list--unimportant))
      (setq dc-files-list--web         (append '("hts" "htz" "tes" "ist" "latex") dc-files-list--web))
      (setq dc-files-list--binaries    (append '("p2a2")            dc-files-list--binaries))
      (setq dc-files-list--graphics    (append '("a2d" "rle")       dc-files-list--graphics))
      ;;(message "END d-init-dired-colours")
      ;;(beep)
      ;;(sit-for 1)
      ))

  (d-init-dired-colours)

  (progn
    (setq compile-history nil)
    (setq compile-history (cons "cd ~/book/jtw && make test.pdf"        compile-history))
    (setq compile-history (cons "cd ~/book/lisp++ && make lisp++11.pdf" compile-history))
    (setq compile-history (cons "cd ~/hairy-lemon/src/50webs-com && make m4 m5" compile-history))
    )

  (d-emergency-set-load-path)

  ;;(load-file (concat (car load-path) "/d-start.el"))

  (setq d-message-on t)

  (message "cp7")

  (setq file-name-history (cons "~www/dlisp/" file-name-history))

  (message "cp8")

  (setq inhibit-startup-screen t)

  (defun beep ()
    (if visible-bell
	(ding)
      (if (file-exists-p "/media/www/C80GB/WINDOWS/Media/ding.wav")
	  (play-sound (list 'sound :file "/media/www/C80GB/WINDOWS/Media/ding.wav" :volume 1.0))
	(if (file-exists-p "/media/www/C1TB/Windows/Media/ding.wav")
	    (play-sound (list 'sound :file "/media/www/C1TB/Windows/Media/ding.wav"))))
      ))

  (message "cp9")

  ;;(let ((visible-bell nil)) (beep))

  ;; NOTE: Inits frame to appear as fullscreen maximized
  ;;(add-to-list 'default-frame-alist '(fullscreen . maximized))

  (setq tags-table-list
	'( ;;"/media/www/C1TB/Program Files (x86)/emacs-23.1/lisp/"
	  "~/lisp++-projects/TAGS"
	  "~www/dlisp/TAGS"
	  "~www/dlisp/experimental/TAGS"
          "~/book/TAGS"
          "~/book/lisp++/TAGS"
          "~/preprocessors/working/TAGS"
	  ;;"~/c2java/TAGS"
	  ;;"~/gnu-java-training-wheels/TAGS"
	  ;;"~/jtw-tutorials-here/TAGS")
	  ))

  (setq d-message-on t)

  (message "cp10")

  (defadvice d-super-f3 (around patch-many activate)
    (if (y-or-n-p "Really save *.c files?")
	ad-do-it))

  (defadvice d-f2 (around patch-many activate)
    (if (y-or-n-p "Really save *.c files?")
	ad-do-it))

  (defun d-f3-a ()
    (interactive)
    (let ((ptr (buffer-list)))
      (while ptr
	(when (buffer-live-p (car ptr))
	  (set-buffer (car ptr))
	  (if (buffer-file-name)
	      (if (and (not (string-match "/TAGS" (buffer-file-name)))
		       (not (string= (buffer-file-name) "/media/www/C80GB/allegro-403/docs/txt/allegro.txt"))
		       (not (string-match "/A[0-9]+\\.c$" (buffer-file-name)))
		       (not (string-match "/A[0-9]+\\.c2j$" (buffer-file-name)))
		       )
		  (kill-buffer (car ptr)))))
	(setq ptr (cdr ptr))) ;; END WHILE!
      ))

  (defun d-f3-b ()
    "kills dired buffers"
    (let ((ptr (buffer-list)))
      (while ptr
	(if (and (buffer-live-p (car ptr))
		 (save-excursion
		   (set-buffer (car ptr))
		   (and (eq major-mode 'dired-mode)
			(not (string-match "/bamboo_system_files/"  default-directory))
			(not (string-match "/Driver Pack Solution/" default-directory))
			(not (string-match "/wordpress/"            default-directory))
			)))
	    (kill-buffer (car ptr)))
	(setq ptr (cdr ptr)))))

  (defun d-f3-c ()
    "Also kills dired buffers"
    (let ((ptr (buffer-list)))
      (while ptr ;;(setq ptr (list (get-buffer " SPEEDBAR")))
	(cond
	 ((and (buffer-live-p (car ptr))
	       (buffer-name (car ptr))
	       (= (aref (buffer-name (car ptr)) 0) ?*)
	       (not (d-is-good-buffer (car ptr))))
	  (kill-buffer (car ptr)))
	 ((and (buffer-live-p (car ptr))
	       (save-excursion
		 (set-buffer (car ptr))
		 (and (not (buffer-file-name))
		      (buffer-name)
		      (eq major-mode 'dired-mode)
		      (not (string-match "/bamboo_system_files/"  default-directory))
		      (not (string-match "/Driver Pack Solution/" default-directory))
		      (not (string-match "/wordpress/"            default-directory))
		      )))
	  (kill-buffer (car ptr)))
	 ((and (buffer-live-p (car ptr))
	       (save-excursion
		 (set-buffer (car ptr))
		 (and (not (buffer-file-name))
		      (buffer-name)
		      (/= (aref (buffer-name) 0) ?\ )
		      (/= (aref (buffer-name) 0) ?*)
		      (not (string= "bamboo_system_files"  (buffer-name)))
		      (not (string= "Driver Pack Solution" (buffer-name)))
		      (not (string= "wordpress"            (buffer-name)))
		      )))
	  (kill-buffer (car ptr))))
	(setq ptr (cdr ptr)))))

  (message "cp11 Faggot")

  (global-set-key [f3] 'f3)

  (defun f3 ()
    (interactive)
    (d-f3-a)
    (d-f3-b)
    (d-f3-c)
    )

  (message "cp12 Maggot")

  ;;(run-with-timer 5 nil 'd-init-dired-colours)
  ;;(describe-variable 'timer-list)

  (global-auto-revert-mode 1)

  (setq debug-ignored-errors (remove "Containing expression ends prematurely" debug-ignored-errors))

  ;; NOTE CAREFUL: error in this file causes the rest of .emacs to fail loading
  (condition-case err
      (if (file-exists-p "~/c2java/patch-c2j.el")
	  (load-file "~/c2java/patch-c2j.el"))
    (error (message "Failed to load ~/c2java/patch-c2j.el"))
    )

  (when (fboundp 'd-xmodmap)
    (message "cp13")
    (d-xmodmap)
    (message "cp14")
    )

  (global-set-key [pause] 'electric-buffer-list)

  (require 'speedbar)

  (message "cp15")

  (run-with-timer 5 nil 'd-fonts--init-dired-colours)

  (setq d-done t)

  (put 'dired-find-alternate-file 'disabled nil)
  (setq use-file-dialog nil)

  (message "cp16")

  ;;(when os-type--linux-p
  ;;  (run-with-timer 10 10 'd-xmodmap)
  ;;  )

  (progn
    (load-file "~www/gnu-java-training-wheels/manual/tesinfo-mode.el")
    )

  (setq debug-ignored-errors (remove 'buffer-read-only debug-ignored-errors))

  (message "cp17")

  (defun dos2unix ()
    (interactive)
    (save-excursion
      (goto-char (point-min))
      (while (re-search-forward (make-string 1 ?\r) nil t)
	(replace-match ""))))

  (setenv "IS_DAVIN" "t")
  (setenv "IS_DAVINS_COMPUTER" "t")

  (package-initialize)
  (setq-default tabulated-list-use-header-line nil)

  (defun elpas ()
    (interactive)
    (package-list-packages))

  (defalias 'elpa 'elpas)

  (defvar package-archives)
  (setq package-archives
	'(( "gnu elpa" . "http://elpa.gnu.org/packages/")
	  ( "melpa"    . "http://melpa.milkbox.net/packages/") ))

  (progn
    (prefer-coding-system 'utf-8)
    (coding-system-change-eol-conversion 'utf-8 'unix))

  (message "cp18")

  (d-emergency-set-load-path)

  ;;(message "load-path=%s" (prin1-to-string load-path))

  (message "cp19")

  (setq auto-mode-alist
	(append '(("\\.lisp\\+\\+$" . lisp++-mode)
		  ) auto-mode-alist))

  (custom-set-variables
   ;; custom-set-variables was added by Custom.
   ;; If you edit it by hand, you could mess it up, so be careful.
   ;; Your init file should contain only one such instance.
   ;; If there is more than one, they won't work right.
   )
  (custom-set-faces
   ;; custom-set-faces was added by Custom.
   ;; If you edit it by hand, you could mess it up, so be careful.
   ;; Your init file should contain only one such instance.
   ;; If there is more than one, they won't work right.
   '(match ((t (:background "darkgreen")))))

  (d-emergency-set-load-path)

  (defun d-f5 ()
    (interactive)
    ;;(message "major-mode=%s" major-mode)
    (describe-key [tab])
    )

  (d-emergency-set-load-path)

  (defun d-f5 ()
    (interactive)
    (message "major-mode=%s" major-mode)
    )

  (global-set-key [f5] 'd-f5)

  (progn
    (add-to-list 'load-path "~/dlisp/imported-stuff/")
    (require 'ace-jump-mode)
    (define-key global-map (kbd "C-c SPC") 'ace-jump-mode)
    (load-file "~/dlisp/imported-stuff/paredit.el")
    )

  (progn
    (global-set-key [S-down-mouse-1] 'ignore)
    (global-set-key [C-down-mouse-2] 'ignore)
    (global-set-key [C-down-mouse-1] 'ignore)

    (global-set-key [(control left)]  'd-backward-sexp)
    (global-set-key [(meta left)]     'd-backward-sexp)
    (global-set-key [(shift left)]    'd-backward-sexp)

    (global-set-key [(control right)] 'd-forward-sexp)
    (global-set-key [(meta right)]    'd-forward-sexp)
    (global-set-key [(shift right)]   'd-forward-sexp)

    (global-set-key [f4] 'd-f4)

    (global-set-key [delete]              'd-delete-key)
    (safe-require 'd-key-nav)
    )
  )

(message "cp20")

(defmacro d-incf (i)
  `(setq ,i (1+ ,i)))

(defmacro d-incf (i)
  (list 'setq i (list '1+ i)))

;;(setq x 123)
;;(d-incf x)

(defun d-load-file (file)
  ;;(d-assert (string= d-target-dir (concat (getenv "PWD") "/lisp++-projects"))) ;; casey
  (message "*** called d-load-file in file=%s" file)
  (load-file (concat d-target-dir "/" file)))

(setenv "IS_DAVINS_COMPUTER" "1")
(message "*** twinkle")
(progn
  (setq pwd (getenv "PWD"))
  (setq d-target-dir (concat pwd "/lisp++-projects/")) ;; loriar
  (setq load-path (cons (concat pwd "/preprocessors/") load-path))
  (setq load-path (cons (concat pwd "/dlisp/") load-path))
  ;;(d-load-file "lisp++2c++.el")
  )

(progn
  (setq load-path (delete "/home/www/preprocessors/dlisp" load-path))
  (setq load-path (delete "/home/www/preprocessors/lisp++-projects" load-path))
  (setq load-path (delq nil load-path))
  )

(defalias 'd-directory-files 'directory-files)

(progn
  (make-face 'red-face)
  (setq red-face 'red-face)
  (make-face-bold 'red-face)
  (defalias 'read-str 'd-read-str)
  )

;;(setq d-target-dir (concat (getenv "PWD") "/lisp++-projects/"))

;;(read-str "line001")
;;(d-read-str "line001")

(message "zulu")

(defadvice describe-text-properties (after d-fonts activate)
  (switch-to-buffer "*Help*"))

(progn
  ;;(setq d-target-dir (expand-file-name "~/lisp++-projects/"))
  ;;(load-file (concat d-target-dir "lisp++2c++.el"))
  )

(defun eb ()
  (interactive)
  (save-excursion
    (save-some-buffers 'NO-QUESTIONS)
    (eval-buffer)
    (find-file "~/dlisp/experimental/new.el")
    (eval-buffer)
    (kill-buffer)
    )
  )

;; COOL! font online works...
;; (d-fonts)
(defun d-set-default-font ()
  (set-default-font "Courier New-18")
  )

(add-hook 'emacs-startup-hook 'd-set-default-font)
(d-set-default-font)

(progn
  (require 'early-bindings)
  (require 'd-make-faces)
  (require 'd-syntax-highlighting)
  (require 'lisp++-mode)
  (message "About to do require 'd-key-nav.el")
  (require 'dired-colours)
  (require 'd-key-nav)
  (message "Done require 'd-key-nav.el")
  (require 'd-cc)
  (require 'd-lisp)
  (require 'tes-mode)
  (require 'd-auto-mode-alist)
  (require 'd-speedbar)
  (require 'd-keys)
  (require 'd-hippie)
  (require 'd-dired)
  ;;(require 'd-key-nav)
  (set-face-italic 'font-lock-comment-face t)
  (set-face-background 'match "#ffff00")
  (set-face-foreground 'match "#000")
  (make-face-bold 'match)
  (make-face-unbold 'font-lock-variable-name-face)
  ;;(message "**** Sitting for 3 seconds")
  ;;(sit-for 3)
  (progn
    (d-make-face 'dired-marked  "#9999ff" "#ffffff")
    (d-make-face 'dired-flagged "#ff9999" "#ffffff"))
  )

(load-file "~/dlisp/experimental/new.el")

(setq d-target-dir "~/preprocessors/")
(setq truncate-lines 8)
;;; BEGIN Lisp++, java-training-wheels stuff
(setq d-target-dir "/usr/preprocessors/lisp++-projects")
;;(setq load-path (append "/usr/preprocessors/dlisp" "/usr/preprocessors/lisp++-projects"
;;                load-path))
(d-emergency-set-load-path)
;; Remove the following line to disable Davin's colorisation prefs.
(setq prefs-jtw-mode-patch-colors-p t)
(require 'd-start)
;;(load-file "/usr/preprocessors/lisp++-projects/lisp++2c++.el")
;;; END Lisp++, java-training-wheels stuff
;;(load-file "~/lisp++-projects/lisp++2c++.el")

;;; FIXME!
(defun find-overlays-specifying (prop)
            (let ((overlays (overlays-at (point)))
                  found)
              (while overlays
                (let ((overlay (car overlays)))
                  (if (overlay-get overlay prop)
                      (setq found (cons overlay found))))
                (setq overlays (cdr overlays)))
              found))

;;(find-overlays-specifying (point))


